//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:4.0.30319.42000
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

using System.Linq;
using Tecan.Sila2;
using Tecan.Sila2.Client;
using Tecan.Sila2.Server;

namespace Tecan.Sila2.Cancellation
{
    
    
    /// <summary>
    /// A class that exposes the ICancelController interface via SiLA2
    /// </summary>
    [System.ComponentModel.Composition.ExportAttribute(typeof(IFeatureProvider))]
    [System.ComponentModel.Composition.PartCreationPolicyAttribute(System.ComponentModel.Composition.CreationPolicy.Shared)]
    public partial class CancelControllerProvider : IFeatureProvider
    {
        
        private ICancelController _implementation;
        
        private Tecan.Sila2.Server.ISiLAServer _server;
        
        private static Tecan.Sila2.Feature _feature = FeatureSerializer.LoadFromAssembly(typeof(CancelControllerProvider).Assembly, "CancelController.sila.xml");
        
        /// <summary>
        /// Creates a new instance
        /// </summary>
        /// <param name="implementation">The implementation to exported through SiLA2</param>
        /// <param name="server">The SiLA2 server instance through which the implementation shall be exported</param>
        [System.ComponentModel.Composition.ImportingConstructorAttribute()]
        public CancelControllerProvider(ICancelController implementation, Tecan.Sila2.Server.ISiLAServer server)
        {
            _implementation = implementation;
            _server = server;
        }
        
        /// <summary>
        /// The feature that is exposed by this feature provider
        /// </summary>
        /// <returns>A feature object</returns>
        public Tecan.Sila2.Feature FeatureDefinition
        {
            get
            {
                return _feature;
            }
        }
        
        /// <summary>
        /// Registers the feature in the provided feature registration
        /// </summary>
        /// <param name="registration">The registration component to which the feature should be registered</param>
        public void Register(IServerBuilder registration)
        {
            registration.RegisterUnobservableCommand<CancelCommandRequestDto, EmptyRequest>("CancelCommand", CancelCommand);
            registration.RegisterUnobservableCommand<CancelAllRequestDto, EmptyRequest>("CancelAll", CancelAll);
        }
        
        /// <summary>
        /// Executes the Cancel Command command
        /// </summary>
        /// <param name="request">A data transfer object that contains the command parameters</param>
        /// <returns>The command response wrapped in a data transfer object</returns>
        protected virtual EmptyRequest CancelCommand(CancelCommandRequestDto request)
        {
            try
            {
                request.Validate();
                _implementation.CancelCommand(request.CommandExecutionUUID.TryExtract(_server, "org.silastandard/core.commands/CancelController/v1/Command/CancelCommand/Paramete" +
                            "r/CommandExecutionUUID"));
                return EmptyRequest.Instance;
            } catch (System.ArgumentException ex)
            {
                if ((ex.ParamName == "commandExecutionUUID"))
                {
                    throw _server.ErrorHandling.CreateValidationError("org.silastandard/core.commands/CancelController/v1/Command/CancelCommand/Paramete" +
                            "r/CommandExecutionUUID", ex.Message);
                }
                throw _server.ErrorHandling.CreateUnknownValidationError(ex);
            } catch (InvalidCommandExecutionUUIDException ex)
            {
                throw _server.ErrorHandling.CreateExecutionError("org.silastandard/core.commands/CancelController/v1/DefinedExecutionError/InvalidC" +
                        "ommandExecutionUUID", "\n      The given Command Execution UUID does not specify a command that is curren" +
                        "tly being executed.\n    ", ex.Message);
            } catch (OperationNotSupportedException ex)
            {
                throw _server.ErrorHandling.CreateExecutionError("org.silastandard/core.commands/CancelController/v1/DefinedExecutionError/Operatio" +
                        "nNotSupported", "\n      Canceling is not supported for the SiLA 2 Command with the\n      specified" +
                        " CommandExecutionUUID.\n    ", ex.Message);
            }
        }
        
        /// <summary>
        /// Executes the Cancel All command
        /// </summary>
        /// <param name="request">A data transfer object that contains the command parameters</param>
        /// <returns>The command response wrapped in a data transfer object</returns>
        protected virtual EmptyRequest CancelAll(CancelAllRequestDto request)
        {
            request.Validate();
            _implementation.CancelAll();
            return EmptyRequest.Instance;
        }
        
        /// <summary>
        /// Gets the command with the given identifier
        /// </summary>
        /// <param name="commandIdentifier">A fully qualified command identifier</param>
        /// <returns>A method object or null, if the command is not supported</returns>
        public System.Reflection.MethodInfo GetCommand(string commandIdentifier)
        {
            if ((commandIdentifier == "org.silastandard/core.commands/CancelController/v1/Command/CancelCommand"))
            {
                return typeof(ICancelController).GetMethod("CancelCommand");
            }
            if ((commandIdentifier == "org.silastandard/core.commands/CancelController/v1/Command/CancelAll"))
            {
                return typeof(ICancelController).GetMethod("CancelAll");
            }
            return null;
        }
        
        /// <summary>
        /// Gets the property with the given identifier
        /// </summary>
        /// <param name="propertyIdentifier">A fully qualified property identifier</param>
        /// <returns>A property object or null, if the property is not supported</returns>
        public System.Reflection.PropertyInfo GetProperty(string propertyIdentifier)
        {
            return null;
        }
    }
}

